"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withRunner = void 0;

var _react = _interopRequireDefault(require("react"));

var _addons = require("@storybook/addons");

var _Preview = require("./components/Preview");

var _constants = require("./constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var argsRegexp = /^(\s*)(args|\(args\))(\W+)/;
var withRunner = (0, _addons.makeDecorator)({
  name: "withRunner",
  parameterName: _constants.PARAM_KEY,
  wrapper: function wrapper(storyFn, context) {
    var storySource = context.parameters[_constants.SOURCE_KEY];
    var options = context.parameters[_constants.PARAM_KEY] || {};

    var _useState = (0, _addons.useState)((storySource === null || storySource === void 0 ? void 0 : storySource.source) || ""),
        _useState2 = _slicedToArray(_useState, 2),
        code = _useState2[0],
        setCode = _useState2[1];

    (0, _addons.useChannel)(_defineProperty({}, _constants.EVENTS.SET_CODE, setCode));
    var hasArgs = argsRegexp.test(code);
    var scope = (0, _addons.useMemo)(function () {
      if (!hasArgs) return options.scope;
      return _objectSpread(_objectSpread({}, options.scope), {}, {
        args: context.args
      });
    }, [options.scope, context.args, hasArgs]);

    if (options.disable || !storySource) {
      return storyFn(context);
    }

    var preview = /*#__PURE__*/_react["default"].createElement(_Preview.Preview, {
      code: hasArgs ? code.replace(argsRegexp, "$1()$3") : code,
      scope: scope
    });

    var Wrapper = options.wrapper;
    if (Wrapper) return /*#__PURE__*/_react["default"].createElement(Wrapper, null, preview);
    return preview;
  }
});
exports.withRunner = withRunner;